package com.mysql.grt;

import java.util.HashMap;
import java.util.Iterator;

public class GrtHashMap implements GrtXml {
	protected HashMap map = new HashMap();
	
	protected Object owner = null;
	
	public GrtHashMap() {
	}
	
	public GrtHashMap(Object owner) {
		super();

		this.owner = owner;
	}
	
	public int size() {
		return map.size();
	}
	
	public GrtHashMap addObject(String key, Object item) {
		map.put(key, item);

		// if the owner of this object is a GrtObject,
		// notify the change
		if ((owner != null) && (GrtObject.class.isAssignableFrom(owner.getClass())))
			Grt.getInstance().objectChanged((GrtObject) owner);
		
		return this;
	}
	
	public Object getObject(String key) {
		return map.get(key);
	}
	
	public void remove(String key) {
		map.remove(key);

		// if the owner of this object is a GrtObject,
		// notify the change
		if ((owner != null) && (GrtObject.class.isAssignableFrom(owner.getClass())))
			Grt.getInstance().objectChanged((GrtObject) owner);
	}
	
	public String getGrtXml() {
		return getGrtXml("");
	}
	
	public String getGrtXml(String keyTag) {
		String xml = "<value type=\"dict\""+keyTag+">\n";

		Iterator keys = map.keySet().iterator();
		
		while (keys.hasNext()) {
			String key = (String) keys.next();
			xml = xml + Grt.getObjectAsXml(map.get(key), " key=\""+key+"\"");
		}
		
		return xml + "</value>\n";
	}
}
